<template>
  <div>
    <v-card
      :loading="isLoadingCalificacionDisciplina"
      tile
      raised
      elevation="3"
      class="card"
      :to="{
        name: 'sistema_informacion_dashboard_disciplinas_disciplina',
        params: {
          disciplina: serviceCommons.objectToBase64(disciplina)
        }
      }"
    >
      <IdGrafico id="002" />
      <div class="cardHeader">
        <div>{{ disciplina.descripcion }}</div>
        <div class="porcentaje">
          {{ calificacionDisciplina.calificacion_final }} %
          <img
            src="@/assets/img/right.svg"
            class="flechas"
          />
        </div>
      </div>
      <div class="cardBoby">
        <div style="padding-left: 20px;">Calificación final de la Disciplina a Nivel Negocio</div>
        <div class="grafica">
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            v-show="isLoadingCalificacionDisciplina"
          ></v-skeleton-loader>
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            v-show="isLoadingCalificacionDisciplina"
          ></v-skeleton-loader>
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            :loading="isLoadingCalificacionDisciplina"
          >
            <span class="bold">Negocios</span>
            <template
              v-for="(itemCalificacionNegocioDisciplina,
              indexItemCalificacionNegocioDisciplina) in calificacionDisciplina.negocios"
            >
              <div :key="indexItemCalificacionNegocioDisciplina" class="negocio">
                <div class="imga">
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    :src="itemCalificacionNegocioDisciplina.logo_image"
                    :lazy-src="itemCalificacionNegocioDisciplina.logo_image"
                  />
                </div>
                <div class="medidor">
                  <div
                    class="porcentaje"
                    v-bind:style="{
                      width:
                        itemCalificacionNegocioDisciplina.calificacion + '%',
                      backgroundColor:
                        itemCalificacionNegocioDisciplina.rango.detalle
                    }"
                  >{{ itemCalificacionNegocioDisciplina.calificacion }}%</div>
                </div>
              </div>
            </template>
          </v-skeleton-loader>
        </div>
      </div>
    </v-card>
  </div>
</template>
<style scoped>
.contenedorCards {
  display: flex;
}
.card {
  margin: 10px;
  min-height: 183px;
  -webkit-box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
  -moz-box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
  box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
}
.cardHeader {
  height: 40px;
  background-color: #f7f7f7;
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding: 20px;
  font-family: "AvenirNextLTPro-Medium";
}
.cardHeader > .porcentaje {
  display: flex;
  justify-content: center;
  align-items: center;
}
.flechas {
  width: 20px;
  margin-left: 10px;
  cursor: pointer;
}
.cardBoby {
  padding: 10px 0px;
}
.grafica {
  padding-top: 5px;
}
.grafica img {
  width: 100%;
}
.negocio {
  display: flex;
  border-top: solid 1px #f7f7f7;
  border-bottom: solid 1px #f7f7f7;
  margin: 5px 0px;
}
.negocio > .imga {
  width: 61px;
  display: flex;
  align-items: center;
  margin-right: 10px;
  padding-left: 10px;
  justify-content: center;
  height: 20px;
}
.negocio > .medidor {
  width: 81%;
  height: 25px;
}
.negocio > .medidor > .porcentaje {
  height: 25px;
  background-color: grey;
  position: relative;
  border-top-right-radius: 21px;
  border-bottom-right-radius: 21px;
  display: flex;
  align-items: center;
  padding-left: 10px;
  color: white;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import IdGrafico from "@/views/secure/sistema-informacion/dashboards/commons/IdGraficoLabel.vue";
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Disciplina",
  components: {
    IdGrafico
  },
  props: {
    globalFiltersParent: Object,
    disciplina: Object,
    methodsSemaforo: Object
  },
  data() {
    return {
      isLoadingCalificacionDisciplina: true,
      calificacionDisciplina: {}
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    getCalificacionDisciplina() {
      let contentFiltros = {
        filtros: JSON.parse(JSON.stringify(this.disciplina.filtros))
      };
      
      contentFiltros.filtros.id_disciplina = this.disciplina.id_disciplina;
      contentFiltros = JSON.parse(JSON.stringify(contentFiltros));
     
        contentFiltros.filtros.numero_periodo = this.disciplina.filtros.numero_periodo;
        contentFiltros.filtros.anio = this.disciplina.filtros.anio;
      this.isLoadingCalificacionDisciplina = true;
      const self = this;
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/calificacion/disciplina",
          contentFiltros
        )
        .then(response => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCalificacionDisciplina(data);
              }
            } else {
              self.setCalificacionDisciplina([]);
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCalificacionDisciplina = false;
        });
    },
    setCalificacionDisciplina(calificacionDisciplina) {
      const self = this;
      calificacionDisciplina.negocios = calificacionDisciplina.negocios.map(
        itemNegocio => {
          itemNegocio.logo_image = serviceCommons.getLogoImageByIdNegocio(
            itemNegocio.id_negocio
          );
          itemNegocio.rango = self.methodsSemaforo.getRangoByLimit(
            itemNegocio.calificacion
          );
          return itemNegocio;
        }
      );
      this.calificacionDisciplina = calificacionDisciplina;
    }
  },
  created() {
    this.getCalificacionDisciplina();
  }
};
</script>
